package com.test.templatemaker
{
	import com.test.templatemaker.controller.HandleReceivedTemplatesCommand;
	import com.test.templatemaker.controller.StartupCommand;
	import com.test.templatemaker.controller.events.TemplateResultEvent;
	import com.test.templatemaker.model.TemplateModel;
	import com.test.templatemaker.service.GetTemplatesService;
	import com.test.templatemaker.view.SpecsView;
	import com.test.templatemaker.view.SpecsViewMediator;
	import flash.display.DisplayObjectContainer;
	import org.robotlegs.base.ContextEvent;
	import org.robotlegs.mvcs.Context;

	public class TemplateMakerContext extends Context
	{


		public function TemplateMakerContext(contextView:DisplayObjectContainer = null, autoStartup:Boolean = true)
		{
			super(contextView, autoStartup);
		}

		override public function startup():void
		{

			injector.mapSingleton(TemplateModel);
			injector.mapSingleton(GetTemplatesService);

			mediatorMap.mapView(SpecsView, SpecsViewMediator);

			commandMap.mapEvent(TemplateResultEvent.RECEIVED, HandleReceivedTemplatesCommand, TemplateResultEvent);
			commandMap.mapEvent(ContextEvent.STARTUP, StartupCommand);

			// startup
			dispatchEvent(new ContextEvent(ContextEvent.STARTUP));
			super.startup();

		}
	}
}
